/* przyklad zabicia przez inny watek oraz procedury obslugi zakonczenia */
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>

unsigned long tid1,tid2;

void konczenie1(void *param)
{
printf("Obsluga zakonczenia 1\n");
}

void konczenie2(void *param)
{
printf("Obsluga zakonczenia 2\n");
}

void *watek1(void *jak_dlugo)
{
int ile = *(int*)jak_dlugo;
pthread_cleanup_push(konczenie1,NULL);
printf("jestem sobie watek 1\n");
printf("Ide spac na %d sekund \n",ile);
sleep(ile);
/* pthread_cleanup_push(konczenie2,NULL); */
pthread_cleanup_pop(0);
printf("watek 1 skonczyl sie normalnie\n");
/* pthread_cleanup_pop(0); */
return NULL;
}

void *watek2(void *jak_dlugo)
{
int ile = *(int*)jak_dlugo;
printf("jestem sobie watek 2\n");
printf("Ide spac na %d sekund \n",ile);
sleep(ile);
printf("watek 2 usuwa watek 1\n");
pthread_cancel(tid1);
printf("watek 2 skonczyl sie normalnie\n");
return NULL;
}

int main(int argc, char *argv[])
{
int czas1 = 4;
int czas2 = 2;

if (pthread_create(&tid1,NULL,watek1,&czas1))
    perror("blad pthread1");
else
    printf("stworzylismy watek1: %lX\n",(unsigned long int) tid1);
if (pthread_create(&tid2,NULL,watek2,&czas2))
    perror("blad pthread2");
else
    printf("stworzylismy watek2: %lX\n",(unsigned long int)tid2);
pthread_join(tid1,NULL);
pthread_join(tid2,NULL);

exit(0);
}

