#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;

int war = 0;

void *sygnal(void *ile_sekund)
{
printf("sygnal START - tid = %lu\n",pthread_self());
sleep(2);
pthread_mutex_lock(&mutex);
printf("sygnal LOCK - tid = %lu\n",pthread_self());
war = 1;
printf("sygnal PRZED SIGNAL - tid = %lu\n",pthread_self());
pthread_cond_signal(&cond);
printf("sygnal PO SIGNAL - tid = %lu\n",pthread_self());
sleep(3);
pthread_mutex_unlock(&mutex);
printf("sygnal STOP - tid  = %lu \n",pthread_self());
return NULL;
}


void *czekaj(void *ile_razy)
{
printf("czekaj START - tid = %lu\n",pthread_self());
pthread_mutex_lock(&mutex);
printf("czekaj LOCK - tid = %lu\n",pthread_self());
while(!war)
    {
    printf("czekaj while przed wait - tid = %lu\n",pthread_self());
    sleep(1);
    pthread_cond_wait(&cond,&mutex);
    printf("czekaj while po wait - tid = %lu\n",pthread_self());
    }
printf("czekaj modyfikacja warunku - tid = %lu\n",pthread_self());
war = 0;
pthread_mutex_unlock(&mutex);
printf("czekaj STOP - tid  = %lu \n",pthread_self());
return NULL;
}

int main(int argc, char *argv[])
{
unsigned long tid1,tid2;
if (pthread_create(&tid1,NULL,sygnal,NULL))
    perror("blad pthread1");
else
    printf("stworzylismy wtek1: %lu\n",(unsigned long int) tid1);
if (pthread_create(&tid2,NULL,czekaj,NULL))
    perror("blad pthread2");
else
    printf("stworzylismy wtek2: %lu\n",(unsigned long int)tid2);
/* jeeli chcemy mie pewno e wynik bdzie po zakoczeniu wtkw to musimy na nie poczeka */
pthread_join(tid1,NULL);
pthread_join(tid2,NULL);

exit(0);
}

